#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, t, k = 2;
    vector<int> a;
    vector<pair<int, int>> quer;
    int b[500100];
    b[1] = 2;
    cin >> n >> t;
    for(int i = 0; i < n; i++){
        int x;
        cin >> x;
        a.push_back(x);
    }
    for(int i = 0; i < t; i++){
        int l, r;
        pair<int, int> pom;
        cin >> l >> r;
        pom.first = l;
        pom.second = r;
        quer.push_back(pom);

    }
    for(int i = 2; i < 500100; i++){
        if(i < k)
            b[i] = k;
        else{
            k = k*2;
            b[i] = k;
        }
    }
    for(int i = 0; i < t; i++){
        int ans = 0;
        map<int, int> m;
        pair<int, int> pom;
        pom = quer[i];
        int l = pom.first;
        int r = pom.second;
        l--;
        r--;
        for(int j = l; j <= r; j++){
            m[b[a[j]]]++;
        }
        for(auto& k:m){
            if(k.second > ans)
                ans = k.second;
        }
        cout << ans << endl;
    }
    return 0;
}